{-------------------------------------------------------------------------------
  :: Iczelion's PE Tutorial 6 for Delphi ::
  translated by Sunshine

  Shows the Import Table of a PE File using Filemapping.

  Have a look at readme.txt for further information.

  Sunshine, February 2003
-------------------------------------------------------------------------------}

program PeTut6;

uses
  Windows, Messages, commdlg, pelib;

const
  WindowWidth = 365;
  WindowHeight = 355;

var
  //OPENFILENAME
  ofn : OPENFILENAME;
  filterstring : LPCTSTR =
                 'Executable Files (*.exe, *.dll)'+#0+'*.exe;*.dll'+#0+
                 'All Files (*.*)'+#0+'*.*'+#0+#0;
  filename : array[0..MAX_PATH] of char;

  hFile : THandle;
  hmapping : THandle;
  pmapping : Pointer;

  Pdosh         : PIMAGE_DOS_HEADER;
  peh           : PIMAGE_NT_HEADERS;
  dat           : DWORD;
  IID           : PIMAGE_IMAGE_IMPORT_DESCRIPTOR;
  IIDRva, IIDOffset : DWORD;
  ThunksOffset : DWORD;
  Importname : PIMAGE_IMPORT_BY_NAME;
  Rvafunction : DWORD;

  h : WORD;



{$R Petut6.RES}


function RVA2Offset(Rva : DWORD; pmap : Pointer) : DWORD;
var
  sectionh      : PIMAGE_SECTION_HEADER;
  section_count : Integer;
  i             : Integer;
begin
   section_count := peh.FileHeader.NumberOfSections;
    //Sectiontable
    sectionh := PIMAGE_SECTION_HEADER(LongWord(peh) + Longword(sizeof(IMAGE_NT_HEADERS)));


    for i := 1 to section_count do   // loop through each section
    begin
      If (Rva >= Sectionh.VirtualAddress) and (RVA < Sectionh.VirtualAddress + Sectionh.SizeofRawData{PhysicalAddress}) then
      begin
         result := Sectionh.PointerToRawData + (RVA - Sectionh.VirtualAddress);
      end;

      sectionh := PIMAGE_SECTION_HEADER(Longword(sectionh) + longword(sizeof(IMAGE_SECTION_HEADER)));

    end;
end;


procedure ClearListbox(hwnd: HWND);
var
  listcount : Integer;
begin
  repeat
    Listcount := SendMessage(GetDlgItem(hwnd,102), LB_GETCOUNT, 0, 0);
    SendMessage(GetDlgItem(hwnd,102), LB_DELETESTRING, 0, 0);
  until (listcount = 0);
end;


procedure ShowText(hwnd: HWND; Mytext : pchar; arg : DWORD);
var
  buffer: array [0..60] of Char;
begin
  wvsprintf(buffer,mytext, pchar(@arg));
  SendMessage(getdlgitem(hwnd,102), LB_INSERTSTRING, -1, Integer(@buffer));
end;



procedure ShowImportFunctions(hwnd : Hwnd);
var
  buffer: array [0..60] of Char;
begin
  ClearListbox(hwnd);
  ShowText(hwnd,filename,0);

  dat := peh.Optionalheader.DataDirectory[1].VirtualAddress;
  if dat = 0 then
  begin
    MessageBox(0,pchar('No Import Table found!'), pchar('Error'), MB_OK);
    exit;
  end;


  IIDRva := Peh.OptionalHeader.DataDirectory[1].VirtualAddress;
  IIDoffset := RVA2Offset(IIDRva,pmapping);
  IID := PIMAGE_IMAGE_IMPORT_DESCRIPTOR(Longword(pmapping) + IIDOffset);

  while (IID.FirstThunk <> 0) do
  begin
    ShowText(hwnd,'',0);
    ShowText(hwnd,'==========[IMAGE_IMPORT_DESCRIPTOR]==========',0);
    ShowText(hwnd,'',0);

    ShowText(hwnd,'Original Firstthunk = %08X ',IID.OriginalFirstthunk);
    ShowText(hwnd,'TimeDateStamp =  %08X ',IID.TimeDateStamp);
    ShowText(hwnd,'ForwarderChain =  %08X ',IID.ForwarderChain);
    ShowText(hwnd, pchar(String('Dll Name = ' + pchar(DWORD(pmapping) + Rva2offset(IID.Name1,pmapping)))),0);
    ShowText(hwnd,'FirstThunk = %08X ',IID.FirstThunk);

    // now functions of dll
    if IID.OriginalFirstThunk = 0 then
       ThunksOffset := RVA2Offset(IID.Firstthunk,pmapping) else
       ThunksOffset := RVA2Offset(IID.OriginalFirstthunk,pmapping);

    //ShowText(hwnd,'Thunksoffset : %08X ',ThunksOffset);
    //ShowText(hwnd,'Thunksoffset value : %08X ',PDWORD(DWORD(pmapping) + DWORD(Thunksoffset))^);

    ShowText(hwnd,'',0);
    ShowText(hwnd,'Hint       Function',0);
    ShowText(hwnd,'----------------------------',0);

    while (PDWORD(DWORD(pmapping) + DWORD(Thunksoffset))^<>0) do
    begin
      RvaFunction := RVA2offset(PDWORD(DWORD(pmapping) + DWORD(Thunksoffset))^,pmapping);
      if (PDWORD(DWORD(pmapping) + DWORD(Thunksoffset))^ and $80000000 = 0) then
      begin                                          //ImportbyName
        importName   := PIMAGE_IMPORT_BY_NAME(RvaFunction+DWORD(pmapping));
        h := WORD(importname.hint);
        ShowText(hwnd,pchar(String('%04u     ' + importname.name1)),h);
      end else
      begin                                          //ImportbyOrdinal
        ShowText(hwnd,'%04u     ord.',DWORD(PDWORD(DWORD(pmapping) + DWORD(Thunksoffset))^ and $FFFF));
      end;
      inc(ThunksOffset,4);
    end;

    ShowText(hwnd,'',0);

    IID := PIMAGE_IMAGE_IMPORT_DESCRIPTOR(Longword(IID) + longword(sizeof(IMAGE_IMAGE_IMPORT_DESCRIPTOR)));
   end;
end;

function dlgfunc(hwnd: hWnd; uMsg: DWORD; wParam: wParam; lParam: lParam): bool; stdcall;
var
  x,y : Integer;
begin
  result := true;
  case uMsg of
  WM_CLOSE : PostQuitMessage(0);

  WM_INITDIALOG :                 // Center window
    begin
      x := GetSystemMetrics(SM_CXSCREEN);   
      y := GetSystemMetrics(SM_CYSCREEN);
      MoveWindow(hWnd, (x div 2) - (WindowWidth div 2),
          (y div 2) - (WindowHeight div 2),
          WindowWidth, WindowHeight, true);
    end;

  WM_COMMAND:
     case wParam of
     101 : begin
             ofn.lStructSize := sizeof(ofn);
             ofn.hInstance   := HInstance;
             ofn.lpstrFilter := filterstring;
             ofn.lpstrFile := filename;
             ofn.nMaxFile :=  512;
             ofn.lpstrTitle := 'Choose file...';
             ofn.Flags := OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or
                          OFN_EXPLORER or OFN_HIDEREADONLY;

             if GetOpenFilename(ofn) then
             begin
               hFile := CreateFileA(filename, GENERIC_READ, FILE_SHARE_READ, nil,
                                     OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
               if hFile = INVALID_HANDLE_VALUE then
               begin
                 MessageBox(0,pchar('Could not open file!'), pchar('Error'), MB_ok);
                 exit;
               end;


               hmapping := CreateFileMapping(hFile, nil, PAGE_READONLY, 0, 0, nil);
               if hmapping = 0 then
               begin
                 MessageBox(0,pchar('Could not create file-mapping object!'), pchar('Error'), MB_ok);
                 exit;
               end;

               pmapping := MapViewOfFile(hMapping, FILE_MAP_READ, 0, 0, 0);
               if DWORD(pmapping) = 0 then
               begin
                 MessageBox(0,pchar('Could not map the file!'), pchar('Error'), MB_OK);
                 exit;
               end;

               PDosh := PIMAGE_DOS_HEADER(pmapping);
               Peh := PIMAGE_NT_HEADERS(LongWord(PDosh) + LongWord(PDosh.e_lfanew));
               if (pdosh.e_magic = IMAGE_DOS_SIGNATURE) and (peh.Signature = IMAGE_NT_SIGNATURE)
               then           // If valid PE File go on
                 ShowImportFunctions(hwnd)
               else
                 MessageBoxA(0,pchar('Not a valid PE File'), pchar('Error'), MB_OK);

               //Clean up
               UnmapViewofFile(pmapping);
               CloseHandle(hmapping);
               CloseHandle(hFile);
             end;
           end;
     end;

  else
    result := false;
  end;
end;


begin
   DialogBoxParamA(hInstance, MAKEINTRESOURCE(101),0,@DlgFunc,0);
   ExitProcess(HInstance);
end.
